(*Ŀ
  Source                                                                  
                                                                  
                          From: RANDALL WOODMAN                             
                                                                            
                    Amlior et traduit en franais par                     
$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
$$$$$$$$$$$$$$$$$  $  $$$  $$$  $  $    $$$$   $$$$$$$$$$$$$$$$$$$$$$
$$$$$$$$$$$$$$$$$   $   $$     $$   $   $  $o  $'  $   $$$$$$$$$$$$$$$$$$$$$
$$$$$$$$$$$$$$$$$   $   $$  $  $$   $   $  $7 $  $$$  $$$$$$$$$$$$$$$$$$$$$
$$$$$$$$$$$$$$$$$       $$     $$$     $$    $$  $$$  $$$$$$$$$$$$$$$$$$$$$
$$$$$$$$$$$$$$$$$   $   $   $   $$$   $$$  $$$$$   $   $$$$$$$$$$$$$$$$$$$$$
$$$$$$$$$$$$$$$$$  $  $ $$$ $$$  $$$ $$$$$$    $$$$$$$$$$$$$$$$$$$$$$
$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$$
$ http://www.multimania.com/haypo/ $$$$$$$$$$$$$$$$$$$$$ haypo@ifrance.com $
Ĵ
  Info                                                                    
                                                                    
                        Donne les infos sur le CMOS                         
*)

{$M 3000,0,0}

{-$DEFINE VersionUs: Ecrit le nom des jours en anglais }

Uses Clavier,Convert,EcranTxt;

Const
  _ERREUR = $FF;

  NomJours: array[0..6] of string[9] = ( {$IFDEF VersionUs}
    'Sunday','Monday','Tuesday','Wednesday','Thursday','Friday'  ,'Saturday'
  {$ELSE}
    'Dimanche','Lundi' ,'Mardi'  ,'Mercredi' ,'Jeudi'   ,'Vendredi','Samedi'
  {$ENDIF});

  NomMois: array[1..12] of string [9] = ( {$IFDEF VersionUs}
    'January', 'February', 'March'  ,   'April',   'May',      'June',
    'July',    'August',   'September', 'October', 'November', 'December'
  {$ELSE}
    'Janvier', 'Fvrier',  'Mars',      'Avril',   'Mai',      'Juin',
    'Juillet', 'Aot',     'Septembre', 'Octobre', 'Novembre', 'Dcembre'
  {$ENDIF});

  NomEcrans: array[0..3] of string [10] = ('EGA/VGA', 'CGA 40 colonnes',
                                           'CGA 80 colonnes', 'Monochrome');

  NomLecteurs: array [0..5] of string [11] = ('aucun', '5.25" 360K',
                                           '5.25" 1.2Mo', '3.5" 720K',
                                           '3.5" 1.44Mo', '3.5" 2.88M');
var
  TmpS: string;
  TmpB: byte;

{- Procdure CMOS -----------------------------------------------------------}
procedure CLI; InLine($FA);
procedure STI; InLine($FB);

function LitCmos (Fonction: BYTE) : BYTE; begin
  CLI;
  Port [$70] := Fonction;
  LitCmos := Port [$71];
  STI;
end;

procedure EcritDateCmos; VAR TMPO: byte; begin
  { Lit le jour de la semaine }
  asm
    mov ah,2Ah
    int 21h
    mov [TmpO],al { devrait tre gal  LitCmos(6), mais ce dernier dconne }
  end;

  Write (NomJours [TmpO],', '); { Jour de la semaine }
  {$IFDEF VersionUS}
  Write (NomMois [Bcd2Dec8(LitCmos(8))]  + ' ' { Mois  }
        +Bcd8 (LitCmos (7))); { Jour  }
  {$ELSE}
  Write ('le '+Bcd8 (LitCmos (7))+' ' { Jour  }
        + NomMois [Bcd2Dec8(LitCmos(8))]);  { Mois  }
  {$ENDIF}

  WriteLn (' '+Bcd8(LitCmos ($32))    { Sicle }
              +Bcd8(LitCmos ($09)));   { Anne (entre 0 et 99) }
end;

{$IFDEF VersionUs}
procedure EcritHeureCmos; var Heure: byte; IsPM: boolean; begin
  heure := Bcd2Dec8 (LitCmos (4));
  IsPm := FALSE;

  CASE heure of
  0: heure := 12;
  1..11 : heure := heure;
  12: IsPM := TRUE;
  13..23: begin
    IsPM := TRUE;
    dec (heure,12);
  end end;

  Write (heure,':'               { heure    }
        +Bcd8 (LitCmos($02))+':' { minutes  }
        +Bcd8 (LitCmos(0))+' ');     { secondes }

  if IsPM then Write('PM') else Write('AM');
end;
{$ELSE}
procedure EcritHeureCmos; begin
  WriteLn (Bcd8 (LitCmos(4)) +'h '    { Heure   }
          +Bcd8 (LitCmos(2)) +'min '  { Minute  }
          +Bcd8 (LitCmos(0)) +'s');   { Seconde }
end;
{$ENDIF}

function VerifieTotal : BOOLEAN; var TotalCalcule,TotalCmos: word; begin
  TotalCalcule := 0;

  for TmpB := $10 to $2D do inc (TotalCalcule, LitCmos (TmpB));

  TotalCmos := LitCmos ($2F) +LitCmos($2E)*256;

  if TotalCalcule<>TotalCmos then begin
    Writeln ('Erreur dans la somme des totaux du Cmos');
    Halt;
  end;
end;

begin
  EffaceEcranTxt;

{  asm
    mov [TmpB],0
    mov ah,0C0h
    int 15h
    jnc @PasErreur

    mov [TmpB],al
  @PasErreur:
  end;

  if TmpB<>0 then begin
    Writeln ('Erreur de la fonction C0h de l''interruption 15h!');
    Halt;
  end;}

  if $FC<Mem[$F000: $FFFE] then begin
    Writeln ('Votre ordi n''est non-compatible.');
    Halt;
  end;

  VerifieTotal;

  { Date et heure }
  Writeln (' Info du CMOS');
  Writeln (' ------------');
  Writeln;
  Write ('Nous sommes ');
  EcritDateCmos;
  Write('Il est ');
  EcritHeureCmos;
  WriteLn;

  { Vido et co-processeur }
  WriteLn('Votre vido est du type : ',NomEcrans[(LitCmos ($14) shr 4) and 3]);
  Write ('Vous ');
  if LitCmos ($14) and 1=1 then Write ('possdez',' un ') else Write ('ne ','possdez',' pas de ');
  WriteLn('co-processeur arithmtique');
  Writeln;

  { Lecteurs de disquettes (et disques dur) }
  TmpB := LitCmos ($10) shr 4;
  if TmpB<5 then TmpS := NomLecteurs[TmpB] else TmpS := 'Inconnu ' +Hex8(TmpB);
  WriteLn ('Votre lecteur de disquette A: est au format : ',TmpS);

  TmpB := LitCmos ($10) and 15;
  if TmpB<5 then TmpS := NomLecteurs[TmpB] else TmpS := 'Inconnu ' +Hex8(TmpB);
  Writeln (' et le lecteur "B:" : ',TmpS);

{  Hard0 := LitCmos ($12)  SHR 4;
  Hard1 := LitCmos ($12) AND 15;
  if Hard0=15 then Hard0 := LitCmos($19) else Hard0 := _ERREUR;
  if Hard1=15 then Hard1 := LitCmos($1A) else Hard1 := _ERREUR;
  WriteLn ('Votre disque dur #1 est du type numro : ',Hard0);
  WriteLn (' et le disque #2 : ',Hard1);}
  Writeln;

  { Mmoire }
  WriteLn('Vous possdez ',Word(LitCmos ($15) +LitCmos($16)*256),'Ko de mmoire de base et ',
          Word(LitCmos($17) +LitCmos($18)*256),'Ko de mmoire tendue');

  LitTouche;
end.